
#include <Arduino.h>
#include <avr/pgmspace.h> 
//#include "TimerOne_x.h"
#include "VVVF_sound.h"
//#include "motor_func.h"

//16Kと言いつつ、8Kのデータとして扱う

//#include "shu1_16k.h"//音1
#include "E233_Alert1.h"
#define WAV_DATA1 E233_alert1_data
#define  WAV_LENGTH1 E233_alert1_length

//#include "shu2_16k.h"//音2
#include "E233_Alert3.h"
#define WAV_DATA2 E233_alert3_data
#define  WAV_LENGTH2 E233_alert3_length

//音３
#define WAV_DATA3 E233_alert1_data
#define  WAV_LENGTH3 E233_alert1_length

#include "shu4_16k.h"//音4
#define WAV_DATA4 shu4_16k_data
#define  WAV_LENGTH4 shu4_16k_length


// REF_WAVE_FREQ = 1000000 / (WAV_LENGTH * 62.5)
//#define REF_WAVE_FREQ 12.618
//#define REF_WAVE_FREQ 15.625
//#define SHIFT_PWM 5
#define SHIFT_PWM 5

//#define  COUNT_CONSTANTSPEED  165 /* 33d=1sec  */
#define  COUNT_CONSTANTSPEED   33 /* 33d=1sec  */
#define  THRESHOLD_RATIO       40 /* ノッチオフの加減速しきい値 */

//VVVF
int uplimit; //VVVF配列の上限
int kasoku[15][8];//VVVF配列
//#define CARRER_FREQ 22000
#define CARRER_FREQ 16000


int current_period1 =(double)1000000 / CARRER_FREQ;//VVVF周期

volatile unsigned int pwm_state1 = WAV_LENGTH1 - 1;
//unsigned int interval_count = 3000;
unsigned char sound_num = 0;
unsigned int pwm_length = WAV_LENGTH1 - 1;

unsigned int pwm_add1 = 0;

unsigned int pwm_shift = 8;
//unsigned int pwm_shift = 0;
int current_duty_a = 0;


int gAccRatio = 20;
int gDecRatio = 20;
int gNotchSpdCount = 0;

uint8_t SoundSwitch = 0;
uint8_t SoundState = 1;
uint8_t SoundNotch = 0;
uint8_t SoundVolume = 0;
long gVVVFLPF_buf = 0;

float PrevSpeed = 0;

boolean accel_flag = false;

//割り込みのひな形
void vvvf_int1();

void VVVF_Setup()
{
  //debug
  //pinMode(7, OUTPUT);
  
  //PWM出力ピン D9を出力にセット
  pinMode(VVVF_SOUND_PIN, OUTPUT);
  //Timer1使用
  //Timer1.initialize();
  //初期設定
  //Timer1.pwm(VVVF_SOUND_PIN,0,0);
  //Timer1.attachInterrupt(vvvf_int1,current_period1 / 2);//interruptの設定    

  //31KHzに設定（初期設定でPhaseCorrectPWMモードになっていると思う）
  //D9,D10  キャリア周期:31kHz(分周無し）
  TCCR1B &= B11111000;
  TCCR1B |= B00000001;

  //出力の設定
  if(VVVF_SOUND_PIN == 9)
  {
    TCCR1A |= _BV(COM1A1);
  }
  else //10
  {
    TCCR1A |= _BV(COM1B1);
  }
  
  //interrupt設定
  TIMSK1 = _BV(TOIE1); 
}

void VVVF_SetCV(uint8_t iNo, uint8_t inData)
{
  switch(iNo)
  {
	case 3:
		
		if( inData > 16)
		{
			gAccRatio = 255;
		}
		else
		{
			gAccRatio = inData * 16;
		}
	
		if( gAccRatio <= 0)
	  	{
	  		gAccRatio = 1;
	  	}
		
		break;
	case 4:
		if( inData > 16)
		{
			gDecRatio = 255;
		}
		else
		{
			gDecRatio = inData * 16;
		}
		
		if( gDecRatio <= 0)
	  	{
	  		gDecRatio = 1;
	  	}
  		break;
  case 47:
    if(inData > 9)
    {
      inData = 9;
    }
    SoundSwitch = inData;
    break;
  case 48:
    if(inData > 1)
    {
      inData = 1;
    }
    SoundState = inData;
    break;
  case 49:
    if(inData > 2)
    {
      inData = 2;
    }
    SoundNotch = inData;
    break;
  case 50:
    if( inData > 8)
    {
      inData = 8;//0:min(no sound) ~ 8:max
    }
    SoundVolume = inData;
    break;
  }
}

void VVVF_Cont(uint8_t inF2Flag)
{
  static uint8_t inF2Flag_static = 0x00;
  //音を徐々に大きくする（ブツ音対策）
  if(pwm_shift > (8 - SoundVolume))
  {
    pwm_shift = pwm_shift << 1;
  }
  //変更されていたら鳴らす
  uint8_t temp_flag = inF2Flag_static ^ inF2Flag;
  switch(temp_flag)
  {
    case 0x01:
      pwm_length = WAV_LENGTH1;
      sound_num = 0;
      pwm_state1 = 0;
      break;   
    case 0x02:
      pwm_length = WAV_LENGTH2;
      sound_num = 1;
      pwm_state1 = 0;
      break;   
    case 0x04:
      pwm_length = WAV_LENGTH3;
      sound_num = 2;
      pwm_state1 = 0;
      break;   
    case 0x08:
      pwm_length = WAV_LENGTH4;
      sound_num = 3;
      pwm_state1 = 0;
      break;   
    default:
      break;   
  }
  //最後に値をStaticに入れておく
  inF2Flag_static = inF2Flag;
}

void VVVF_Init()//160917 fujigaya2 
{
  int cv47_Value = SoundSwitch;
  int cv48_Value = SoundState;
}

//void vvvf_int1()
ISR(TIMER1_OVF_vect)
{
  //波形生成用interrupt
  static unsigned char flg = 0;
  //flg++;
  if(flg == 0x03) //4回に1回だけ値を変更32kHZ→8kHz
  {
    flg = 0x00;
  }
  else
  {
    flg++;
    return;
  }
  
  if (pwm_shift != 8)
  {
    int temp_state = 0;
    int temp_value = 0;
   
    //サンプリング場所の管理
    if(pwm_state1 > pwm_length - 1)
    {
      //Lengthを超えたら上限で待機
      temp_state = pwm_length - 1;
    }
    else
    {
      //そうでなければ値を代入
      temp_state = pwm_state1;
      pwm_state1 ++;
    }

    //音色の管理
    switch(sound_num)
    {
      case 0:
        temp_value = pgm_read_byte_near(&WAV_DATA1 [temp_state]);
        break;
      case 1:
        temp_value = pgm_read_byte_near(&WAV_DATA2 [temp_state]);
        break;
      case 2:
        temp_value = pgm_read_byte_near(&WAV_DATA3 [temp_state]);
        break;
      case 3:
        temp_value = pgm_read_byte_near(&WAV_DATA4 [temp_state]);
        break;
    }

    if (VVVF_SOUND_PIN == 9)
    {
      OCR1A=temp_value>>pwm_shift;
    }
    else//(VVVF_SOUND_PIN == 10)
    {
      OCR1B=temp_value>>pwm_shift;
    }
    //pwm_state1 ++;
  }
  else
  {
    if (VVVF_SOUND_PIN == 9)
    {
      OCR1A=0;
    }
    else//(VVVF_SOUND_PIN == 10)
    {
      OCR1B=0;
    }
  }  
}

